package aspectEditor.aspectEditorUtils;
import java.util.jar.JarFile;
import java.util.*;
import java.io.*;
import edu.neu.ccs.demeter.aplib.*;
import edu.neu.ccs.demeter.*;
class OneClassGlob extends ClassGlobSpec {
  protected ClassGlob classglob;
  public ClassGlob get_classglob() { return classglob; }
  public void set_classglob(ClassGlob new_classglob) { classglob = new_classglob; }
  public OneClassGlob() { super(); }
  public OneClassGlob(ClassGlob classglob) {
    super();
    set_classglob(classglob);
  }
  public static OneClassGlob parse(java.io.Reader in) throws ParseException { return new Parser(in)._OneClassGlob(); }
  public static OneClassGlob parse(java.io.InputStream in) throws ParseException { return new Parser(in)._OneClassGlob(); }
  public static OneClassGlob parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
  }
  Enumeration elements() {
    return ClassGlobSet.parse("{" + classglob + "}").elements();
  }
  public String toString() { return classglob.toString(); }
  void universal_trv0_bef(UniversalVisitor _v_) {
    super.universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before(this);
  }

  void universal_trv0_aft(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).after(this);
    super.universal_trv0_aft(_v_);
  }

  void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before_classglob(this, classglob);
    classglob.universal_trv0(_v_);
    ((UniversalVisitor) _v_).after_classglob(this, classglob);
    super.universal_trv0(_v_);
    universal_trv0_aft(_v_);
  }

  void __trav_buildDict_NameMap_trv_bef(__V_NameMap_buildDict __v0) {
    super.__trav_buildDict_NameMap_trv_bef(__v0);
  }

  void __trav_buildDict_NameMap_trv_aft(__V_NameMap_buildDict __v0) {
    super.__trav_buildDict_NameMap_trv_aft(__v0);
  }

  void __trav_buildDict_NameMap_trv(__V_NameMap_buildDict __v0) {
    __trav_buildDict_NameMap_trv_bef(__v0);
    __trav_buildDict_NameMap_trv_aft(__v0);
  }

  void allGlobs_ClassGlobSpec_trv_bef(GlobVisitor v) {
    super.allGlobs_ClassGlobSpec_trv_bef(v);
    ((GlobVisitor) v).before(this);
  }

  void allGlobs_ClassGlobSpec_trv_aft(GlobVisitor v) {
    ((UniversalVisitor) v).after(this);
    super.allGlobs_ClassGlobSpec_trv_aft(v);
  }

  void allGlobs_ClassGlobSpec_trv(GlobVisitor v) {
    allGlobs_ClassGlobSpec_trv_bef(v);
    ((UniversalVisitor) v).before_classglob(this, classglob);
    classglob.allGlobs_ClassGlobSpec_trv(v);
    ((UniversalVisitor) v).after_classglob(this, classglob);
    allGlobs_ClassGlobSpec_trv_aft(v);
  }

  void __trav_match_ClassGlobSpec_trv_bef(__V_ClassGlobSpec_match __v0) {
    super.__trav_match_ClassGlobSpec_trv_bef(__v0);
  }

  void __trav_match_ClassGlobSpec_trv_aft(__V_ClassGlobSpec_match __v0) {
    super.__trav_match_ClassGlobSpec_trv_aft(__v0);
  }

  void __trav_match_ClassGlobSpec_trv(java.util.BitSet nodes, __V_ClassGlobSpec_match __v0) {
    __trav_match_ClassGlobSpec_trv_bef(__v0);
    { java.util.BitSet newnodes = new java.util.BitSet();
      newnodes.set(0);
      newnodes.and(nodes);
      if (!newnodes.equals(new java.util.BitSet())) {
        classglob.__trav_match_ClassGlobSpec_trv(newnodes, __v0);
      }
    }
    __trav_match_ClassGlobSpec_trv_aft(__v0);
  }

  void __trav_map_ClassGlobSpec_trv_bef(__V_ClassGlobSpec_map __v0) {
    super.__trav_map_ClassGlobSpec_trv_bef(__v0);
  }

  void __trav_map_ClassGlobSpec_trv_aft(__V_ClassGlobSpec_map __v0) {
    super.__trav_map_ClassGlobSpec_trv_aft(__v0);
  }

  void __trav_map_ClassGlobSpec_trv(__V_ClassGlobSpec_map __v0) {
    __trav_map_ClassGlobSpec_trv_bef(__v0);
    classglob.__trav_map_ClassGlobSpec_trv(__v0);
    __trav_map_ClassGlobSpec_trv_aft(__v0);
  }

  void __trav_addStrings_ClassGlobSpec_trv_bef(__V_ClassGlobSpec_addStrings __v0) {
    super.__trav_addStrings_ClassGlobSpec_trv_bef(__v0);
  }

  void __trav_addStrings_ClassGlobSpec_trv_aft(__V_ClassGlobSpec_addStrings __v0) {
    super.__trav_addStrings_ClassGlobSpec_trv_aft(__v0);
  }

  void __trav_addStrings_ClassGlobSpec_trv(__V_ClassGlobSpec_addStrings __v0) {
    __trav_addStrings_ClassGlobSpec_trv_bef(__v0);
    classglob.__trav_addStrings_ClassGlobSpec_trv(__v0);
    __trav_addStrings_ClassGlobSpec_trv_aft(__v0);
  }

}
